#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QToolBar>
#include <QTimer>
#include <QPushButton>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QPushButton * pb = new QPushButton(this);
    pb->setText(QLatin1String("Push me to start the test"));
    setCentralWidget(pb);

    connect(pb, SIGNAL(clicked(bool)), this, SLOT(refresh_toolbar()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::refresh_toolbar()
{
    static int gg = 0;

    if(!gg++) { // Install the toolbar
        tb = new QToolBar(this);
        addToolBar(tb);
    }

    QList<QAction*> acts = tb->actions();

    //tb->clear(); // Here actions's memory is not released!

    // This would release those actions and free the memory,
    // Qt-5.9.9-mingw32 does that OK,
    // Qt-5.12.9-msvc2019 and Qt-5.15.1-msvc2019 leaks memory
    foreach (QAction* act, acts) {
        delete act;
    }

    for(int i = 0; i < 150; ++i)
    {
        int title = gg * 1000 + i;
        QAction *action = tb->addAction(QString::number(title));
        action->setData(i);
        action->setCheckable( true );
        action->setChecked( title % 3 );
    }

    if(gg < 1000)
        QTimer::singleShot(100, this, SLOT(refresh_toolbar()));
    else { // remove and delete the toolbar
        QTimer::singleShot(5000, tb, SLOT(deleteLater()));
        removeToolBar(tb);
    }
}
